/*-------------------------------------------------------------------------
This code is copyrighted to BIS : Begeleid Individueel Studeren,
a department of Ministerie Vlaamse Gemeenschap, 2002-2003.
Developping was done in co-operation with Education Services:
tel. +32(0)3/227 02 06 / fax. +32(0)3/227 32 65 info@educationservices.be
-------------------------------------------------------------------------*/

//------------------- CHANGELOG -------------------------------------------
//	CHANGES TO THIS CODE MUST BE COMMENTED IN THIS HEADER BELOW, 
//	AND AT LOCATION INSIDE THE SCRIPT
//	CREATION DATE: 12/11/2002
//	LECTORA TEMPLATE: "TEXT MEERKEUZE" (TMC)
//	REVISION HISTORY:
//	COMMENT CHANGES HERE, INCLUDE AUTHOR, DATE AND DESCRIPTION
//
//  aanpassing 1.3 : feedback initially hidden en met layout (Dirk Pauwels)
//  2003-03-25: Implementation of the SelfCorrection button (Bram Esposito)
//  2003-03-26: Implementation of the Layered Feedback (Bram Esposito)
//  2003-05-26: Development of Diverse Feedback (Bram Esposito)
//  2003-05-27: Optimalisation of feedbackwindow:   (Bram Esposito)
//                  - only using visibility property.
//                  - set the feedbacklayer to appear on the upperright 
//                    corner initially, so it won't flash when clicking 
//                    on submit on slower systems.
//                  - separated the feedbacklayer from the form in Lectora.
//  2003-05-27: Maximum 20 gaps per TMC exercise due to the for loop in
//                    verbeterTMC.
//
//-------------------------------------------------------------------------


//------------------- INDEX -----------------------------------------------
//
//  function toonFeedback(deze)
//  function vulveld(X,Y)
//  function feedbackClick () 
//  function submitButtonClick () 
//  function correctButtonClick ()
//  function resetButtonClick () 
//  
//  function verbeterTMC()
//  function isEenJuistAntwoord(theAnswerNum,i)
//  function self_correct() 
//  
//  function feedbackRequest(deze)
//  function fback(gapID, theValue)
//  function findAnswerNum(theValue, gapIndex) 
//  
//  function autoCorrect(gapID,i)
//  function fillGap(nr,deel)
//  function fb_hide()
//  function fb_show()
//  function resetToInitialState() 
//  function resetGap(gapID,i) 
//  function getIndex(gapID) 
//  
//-------------------------------------------------------------------------



/*################### VARIABLES #########################################*/


//------------------- Declaring variables ---------------------------------
var currFB = 0;
var FBLocked = true;
var isInitialized = 0;
var isSubmitted = 0;
//-------------------------------------------------------------------------


/*################### LECTORA CALLS #####################################*/

//------------------- feedbackRequest(deze) -------------------------------
    function feedbackRequest(deze)
    {
        var theBG = deze.style.backgroundColor;
        if (theBG == '#99ff99' || theBG == '#ffff00' || isSubmitted == 1)
        {
            toonFeedback(deze);
        }
    }
//-------------------------------------------------------------------------

//------------------- INDEX -----------------------------------------------
    function vulveld(X,Y)
    {
        isInitialized = 1;
        fillGap(X,Y)
    }
//-------------------------------------------------------------------------

//------------------- feedbackClick () ------------------------------------
	function feedbackClick () 
	{
		fb_hide();
	}
//-------------------------------------------------------------------------

//------------------- submitButtonClick () --------------------------------
	function submitButtonClick () 
	{
		if (isInitialized !== 0)
		{
			verbeterTMC();
			fb_hide();
            isSubmitted = 1;
		}

	}
//-------------------------------------------------------------------------

//------------------- correctButtonClick () -------------------------------
	function correctButtonClick ()
	{
		if (isSubmitted == 1)
		{
			isInitialized = 0;
			self_correct();
			fb_hide();
            isSubmitted = 0;
		}
	}
//-------------------------------------------------------------------------

//------------------- resetButtonClick () ---------------------------------
	function resetButtonClick () 
	{
		resetToInitialState();
		fb_hide();
        isSubmitted = 0;
	}
//-------------------------------------------------------------------------

/*################### FUNCCTIONS ########################################*/


//---------------------- Correction ---------------------------------------
//      When clicking on the Submit button, the filled in
//      values are checked against the correct answer.
//-------------------------------------------------------------------------

function verbeterTMC()
    {
        for (var i = 0; i < 20 ; i++ )
        {
            theObject = document.getElementById("gap"+i);
            if (theObject)
            {
                if (theObject.value != "")
                {
                    var theAnswerNum = findAnswerNum(theObject.value, i);
                    if (isEenJuistAntwoord(theAnswerNum,i))
                    {
                        theObject.style.background = '#99FF99';
                    } else
                    {
                        theObject.style.background = '#FF9999';
                    }
                } else 
                {
                	theObject.style.border = 'none';
                    theObject.style.display = 'block';
                    theObject.style.background = '#cccccc';
                }
            }
        }
        FBLocked = false;
    } 
//-------------------------------------------------------------------------

//------------------- INDEX -----------------------------------------------
function isEenJuistAntwoord(theAnswerNum,i)
    {
        for (var j=0; j<antw[i].length ;j++ )
        {
            if (antw[i][j] == theAnswerNum)
            {
                return true;
            }
        }
        return false;
    }
//-------------------------------------------------------------------------

//---------------------- Zelf-correctie - 25-03-2003 ----------------------
//		Functie wordt aangeroepen vanuit Lectora door 
//		de correctieknop. Dit aan de hand van volgende
//		code: javascript:self_correct(); in een weblink.
//		Wat doet deze knop/functie? 
//		De cursist klikt op de verbeter knop om de juiste 
//		antwoorden te laten staan en enkel door te gaan 
//		met de foute oefeningen voor een 2e maal in te vullen.
//-------------------------------------------------------------------------
function self_correct() 
    {
	for (var i = 0; i < document.forma.length; i++)
		{
		var gapID = document.forma.elements[i];
		if (gapID.type == "text")
			{
			if (gapID.style.background == "#ff9999" 
			    || gapID.style.background == "#cccccc" )
				{
				if (currFB > 1)
					{
					autoCorrect(gapID,i);
					} else {
					resetGap(gapID,i);
					}
			 	}
			}
		}
	if (!FBLocked)
        {  // Disable clicking 2 times on the SelfCorr button 
            currFB = currFB +1;
            FBLocked = true;
        }
    }
//-------------------------------------------------------------------------


/*################### FEEDBACK ##########################################*/


//------------------- Show Feedback ---------------------------------------
//      Invoked by click on gap
//      Showing a static feedback in the upper right corner
//-------------------------------------------------------------------------

    function toonFeedback(deze)
        {
        if (deze.value != "")
            {
            var gapID = deze.name;
            var theValue = deze.value;
            fback(gapID, theValue);

            fb_show();
            }
        }
//-------------------------------------------------------------------------


//------------------- Invoked by ------------------------------------------
function fback(gapID, theValue)
	{
        gapIndex = getIndex(gapID);
        var theAnswerNum = findAnswerNum(theValue, gapIndex);
        document.all.feedback.innerHTML = fbfout[gapIndex][theAnswerNum];
    }
//-------------------------------------------------------------------------

//------------------- INDEX -----------------------------------------------
function findAnswerNum(theValue, gapIndex) 
    {
        for (var j=0; j<opgave[gapIndex].length ; j++ )
            {
                if (opgave[gapIndex][j] == theValue)
                {
                    return j;
                }
            }
    }
//-------------------------------------------------------------------------


/*#######################################################################*/



//------------------- Fills the gap with the correct answer(s) ------------
function autoCorrect(gapID,i)
    {
        gapID.style.background = '#FFFF00';
        gapID.value = opgave[i][antw[i][0]];
    }
//------------------------------------------------------------------------- 


//------------------------------------------------------------------------- 
function fillGap(nr,deel)
{
	var gapID = document.forma.elements[nr];
	var laagID = document.getElementById(gapID.name).parentNode;
	var breedte;
	breedte = laagID.offsetWidth;
	gapID.value = opgave[nr][deel];
	gapID.style.background = '#FDFEE2';
	gapID.style.border = 'none';
	gapID.style.display = 'block';
}
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
function fb_hide()
    {
        document.all.feedbacklayer.style.visibility = 'hidden';
    }
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
function fb_show()
    {
        document.all.feedbacklayer.style.visibility = 'visible';
    }
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
function resetToInitialState() 
{
	for (var i = 0; i < document.forma.length; i++)
		{
		var gapID = document.forma.elements[i];
		if (gapID.type == "text")
			{
			resetGap(gapID,i)
			}
		}
	currFB = 0;
}
//-------------------------------------------------------------------------

//------------------- Reset a gap to it's initial state -------------------
function resetGap(gapID,i) 
    {
        gapID.style.background = '#FDFEE2';
        gapID.style.display = 'none';
        gapID.style.visibility = "visible"; 
        gapID.value = "";
        document.all.feedback.innerHTML = "";
    }
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
function getIndex(gapID) 
    {
        for (var i=0;i < document.forma.elements.length;i++)
            if (document.forma.elements[i].name == gapID)
                return i;
        return -1;
    }
//-------------------------------------------------------------------------
//---------------------------------- eof ----------------------------------